stages:
  - build
  - test
  - runway

workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
    - if: '$CI_COMMIT_REF_NAME == "main"'

variables:
  BASE_STAGE_IMAGE: $CI_REGISTRY_IMAGE/base:$CI_PIPELINE_ID
  DEPLOYMENT_STAGE_IMAGE: $CI_REGISTRY_IMAGE/deploy:$CI_PIPELINE_ID

image: docker:latest

include:
  - project: 'gitlab-com/gl-infra/platform/runway/ci-tasks'
    ref: v1.6.0 # renovate:managed
    file: 'service-project/runway.yml'
    inputs:
      runway_service_id: eval-code-viewer-78do0s
      image: "$CI_REGISTRY_IMAGE/deploy:$CI_PIPELINE_ID"
      runway_version: v1.6.0 # please keep in sync with `ref` above

build:base:
  stage: build
  services:
    - docker:dind
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build --target base --cache-from ${BASE_STAGE_IMAGE} --tag ${BASE_STAGE_IMAGE} .
    - docker push ${BASE_STAGE_IMAGE}

build:deployment:
  needs: ["build:base"]
  services:
    - docker:dind
  rules:
    - if: '$CI_COMMIT_REF_NAME == "main"'
      when: always
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
      when: never
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker pull ${BASE_STAGE_IMAGE}
    - docker build --target deployment --cache-from ${BASE_STAGE_IMAGE} --build-arg="PROMPT_VERSION=$PROMPT_VERSION" --build-arg="MODEL_EV_USERNAME=$MODEL_EV_USERNAME" --build-arg="MODEL_EV_HASHED_PASSWORD=$MODEL_EV_HASHED_PASSWORD" --build-arg="MODEL_EV_SALT=$MODEL_EV_SALT" --tag ${DEPLOYMENT_STAGE_IMAGE} .
    - docker push ${DEPLOYMENT_STAGE_IMAGE}

verify:jest:
  stage: test
  services:
    - docker:dind
  script:
    - docker compose up -d
    - docker compose exec webapp yarn test

verify:lint:
  stage: test
  services:
    - docker:dind
  needs: ["build:base"]
  script:
    - docker pull ${BASE_STAGE_IMAGE}
    - docker run --rm ${BASE_STAGE_IMAGE} yarn lint
